**************************************************************************
* module    : NOOT.CH
* funktie   : header file for noot.lib
* taal      : Clipper 5.2
* libs      : CATools 3 ,noot.lib
* auteur    : rene nooteboom
* datum     : created 29-4-1991
*             updated 19-08-2005
*************************************************************************
#stdout noot.ch-Version 5.30-aug2005
*************************************************************************
#ifndef DBS_NAME
 #include "dbstruct.ch"
#endif
*************************************************************************
* netwerk
*************************************************************************
#xcommand NETUSE <(db)> RESULT <lresult> [VIA <rdd>] [ALIAS <al>]  ;
 [SECONDS <ntime>] [<new: NEW>] [<exc: EXCLUSIVE>] [<sha: SHARED>]  ;
 [<ro: READONLY>] =>   ;
 <lresult> := netusedbf(<.new.>,<rdd>,<(db)>,<(al)>, ;
  if(<.sha.> .OR. <.exc.>,!<.exc.>,NIL),<.ro.>,<ntime>)
**************************************************************************
* VIDEO
**************************************************************************
* offsets voor static colors[] (2nd dimension) in my_color.prg
*
#define COLOR_CFG 1
#define BL_WH_CFG 2
#define COLOR_DESCR 3
*
* offsets voor static colors[] (first dimension) my_color.prg
* example colors[CR_BLINK][BL_WH_CFG]
*
#define CR_NORMAL 1
#define CR_BOLD 2
#define CR_ENHANCED 3
#define CR_BLINK 4
#define CR_MESSAGE 5
#define CR_WARNING 6
#define CR_SELECT 7
#define CR_GETS 8
#define CR_OLD 9
*
* extract colors from a colorstring
*
#xtranslate STAND_CR(<ccolor>) => token(<ccolor>,",",1)
#xtranslate ENHAN_CR(<ccolor>) => ;
 if(numtoken(<ccolor>,",")>1,token(<ccolor>,",",2),token(<ccolor>,",",1))
#xtranslate UNSEL_CR(<ccolor>) => ;
 token(<ccolor>,",",numtoken(<ccolor>,","))
*
* constants for use with browse object instance variables
*
* example call : browse_obj:colorspec := tbr_colorspec()
*                col_obj:defcolor := BR_CR_MARKED
*                col_obj:colorblock := {|a|if(..,BR_CR_NORMAL,BR_CR_MARKED)}
*
#define BR_CR_NORMAL {1,2}
#define BR_CR_MARKED {3,4}
#define BR_CR_SPECIAL {5,6}
*****************************************************************************
* ENVIRONMENT
*****************************************************************************
#xcommand MY_BEGIN => DEF_ENVIRONMENT ; setblink(.T.) ; color_init() ;
 ; color_set(CR_NORMAL)
#xcommand MY_EINDE => color_set(CR_OLD) ; DEF_EINDE
*****************************************************************************
*****************************************************************************
* simulated extended tbrowse class
*****************************************************************************
#xtranslate :arrayIndex     => :cargo\[1\]
#xtranslate :arrayReference => :cargo\[2\]
#define ABRWS_NUM_IVARS 2
#xtranslate :selected  => :cargo\[3\]
#xtranslate :afterKeys => :cargo\[4\]
#define AB_SEL_NUM_IVARS 4
*****************************************************************************
* MESSAGES
*****************************************************************************
#xcommand MESSAGE START [AT <top>,<left> TO <bot>,<right>]  ;
 [COLOR <ncolornr>] => msg_start(<top>,<left>,<bot>,<right>,<ncolornr>)
#xcommand MESSAGE END => msg_end()
#xcommand MESSAGE DISPLAY <msg> [COLOR <ncolornr>] => msg(<msg>,<ncolornr>)
*****************************************************************************
#xcommand GAUGE <nvar> TOTAL <ntotal> [HEADER <cheader>] [VALUE <nvar2>] ;
 [TEXTVAL <ctext>] [BARSIGN <cbarsign>] [<ton: TONE>] [<cle: CLEAR>] => ;
 gauge(<nvar>,<ntotal>,<cheader>,<ctext>,<nvar2>,<cbarsign>,<.ton.>, ;
  <.cle.>)
#xcommand GAUGE DELETE [<ton: TONE>] => gauge(1,1,,,,,<.ton.>)
*****************************************************************************
*  GET / READ SYSTEM
*****************************************************************************
#xcommand SAVE GETS => push_gets()
#xcommand RESTORE GETS => pop_gets()
*
* popup a get box
*
#xcommand BOXGET <var>            ;
         PROMPT <prom>            ;
         [ BOXCOLOR <boxcolor> ]  ;
         [ PICTURE <pict>  ]      ;
         [ VALID <valid>   ]      ;
         [ ROW <row>       ]      ;
         [ COLUMN <column> ]      ;
         [ <double:DOUBLE> ]      ;
                              =>  ;
      BoxGet(<prom>, <row>, <column>, ;
             getnew( maxrow() + 1, maxcol() + 1, ;
             { | _grumpy | if(pcount() = 0, <var>, <var> := _grumpy ) }, ;
             <(var)>, <pict>, <boxcolor> ), ;
             <{valid}>, <boxcolor>, <.double.> )
*
#xtranslate GETSTRING ( [ AT <r>,<c> ] ;
                      [ MESSAGE <msg> ] ;
                      [ COLOR <clr> ] ;
                      [ DEFAULT <def> ] ;
                      [ PICTURE <pict> ] ) => ;
  GetString(<r>, <c>, <msg>, <clr>, <def>, <pict>)
*
#xcommand READ TIMEOUT AT <n> [ACTION <b>] =>  ;
  aeval(getlist,{|o|o:reader:={|oGet|timedreader(oGet,<n>,<{b}>)}})  ;;
  READ
***************************************************************************
* ARRAY MANIPULATIONS
***************************************************************************
* return largest element in an 1 dim. array
*
#define AMAX(arr) afind(arr,{|i,j| i > j})
*
* return smallest element in an 1 dim. array
*
#define AMIN(arr) afind(arr,{|i,j| i < j})
*
* return longest element in a 1 dim. array (character strings only)
*
#define AMAXLEN(arr) afind(arr,{|i,j| len(i) > len(j)})
*
#xtranslate AAVG(<foo>) => (asum(<foo>) / len(<foo>) )
*
* return shortest element in 1dim array
*
#define AMINLEN(arr) afind(arr,{|i,j| len(i) < len(j)})
**************************************************************************
* SELECTION COMMANDS
**************************************************************************
* picklists and multiple selections
*
#define STOPPEN 2
#xcommand CHOICE [AT <t>,<l>] INTO <elemnr> [ITEMS <items>]  ;
 [ALLOWED <larray>] [ESCAPE <lesc>] [INITIAL <ninitial>] ;
 [TEXT <ctext>] => ;
 <elemnr> := keuzes(<items>,<larray>,<lesc>,<t>,<l>,<ninitial>, ;
  <ctext>)
*
* selection box
*
#xcommand SELECTBOX [AT <t>,<l>] INTO <chosen> ITEMS <items> ;
 [MAX <max>] [SELECTABLE <selectables>] [INITSEL <initsel>] ;
 [START <inithigh>] [CTAG <csign>] => ;
 <chosen> := sel_box(<t>,<l>,<items>,<max>,<selectables>,<initsel>, ;
  <inithigh>,<csign>)
**************************************************************************
* DATES
**************************************************************************
#xtranslate DATETEXT() => STRINGNUM(day(date())) + " " + cmonth(date()) + ;
 " " + str(year(date()),4)
**************************************************************************
#xtranslate IS_CYFERS(<cstring>) => (if(charrem(CYFERS,<cstring>)=="", ;
 .T.,.F.))
**************************************************************************
#xtranslate IS_HEX(<cstring>) => (if(charrem(HEXNUMBERS,<cstring>)=="", ;
 .T.,.F.))
**************************************************************************
* FILES , DISKS
**************************************************************************
* return an array of fieldnames from a dbf
*
#xtranslate DBFFIELDS() => (acolumn(dbstruct(),DBS_NAME))
*
* return the full current dos path(example:c:\clipper5\)
*
#xtranslate CURPATH([<cdrive>]) => n_curpath(<cdrive>)
*
* return the directory from a file spec
*
#xtranslate GIVEDIR(<cfilespec>) => n_givedir(<cfilespec>)
*
* return the drive from a file spec
*
#xtranslate GIVEDRIVE(<cfilespec>) => if(drivespecified(<cfilespec>), ;
 upper(left(alltrim(<cfilespec>),1))+":","")
*
#xcommand COPY_FILE <(old)> TO <(new)> [EVAL <beval> [EVERY <nevery>]] ;
 [BUFFER <nkb>] [<confirm: CONFIRM>] => ;
 copy_file(<(old)>,<(new)>,<{beval}>,<nevery>,<nkb>,<.confirm.>)
***************************************************************************
/*
 offsets voor gebruik bij return array van dest_output() in printio.prg
*/
#define ISCREEN  1
#define IPRINTER 2
#define IFILE    3
***************************************************************************
* specialized gets
***************************************************************************
#xcommand @ <row>,<col> GETPL <var> PICKLIST <list> [LABELS <labels>] ;
 [AT <top>,<left>] [PICTURE <pic>] [WHEN <when>] [VALID <valid>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|oget|pickreader(oget,<row>,<col>,@<var>, ;
  <list>,<labels>,<top>,<left>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
***************************************************************************
#xcommand @ <row>,<col> CHECKBOX <lvar> [WHEN <when>] [VALID <valid>] => ;
 dispcheckbox(<row>,<col>,<lvar>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"lvar"> ;
 ; atail(getlist):block := {|xval|if(xval!=NIL,<lvar>:=xval,<lvar>)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|get|checkboxer(@<lvar>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]
**************************************************************************
#xcommand @ <row>,<col> GETH <var> HELP <chelp> [PICTURE <pic>] ;
 [VALID <valid>] [WHEN <when>] [AT <top>,<left>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|get|helper(get,<chelp>,<top>,<left>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
*************************************************************************
#xcommand @ <row>,<col> GETB <var> BOX <cboxtype> [PICTURE <pic>] ;
 [VALID <valid>] [WHEN <when>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|get|boxedget(get,<cboxtype>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
**************************************************************************
#xcommand RADIO <nvar> BUTTONS <abuttons> [VALID <valid>] [WHEN <when>] => ;
 radiodisplay(<abuttons>,<nvar>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"nvar"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<nvar>,<nvar>:=xval)} ;
 ; atail(getlist):row := 0 ;
 ; atail(getlist):col := 0 ;
 ; atail(getlist):reader := {|get|radio(<abuttons>,@<nvar>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]
**************************************************************************
/*
 GETeXtended met message en error optie
*/
#xcommand @ <row>,<col> GETX <var> [PICTURE <pic>] ;
 [VALID <valid>] [WHEN <when>] [MESSAGE <cmes>] ;
 [ERROR <cerror>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|oget|getxreader(oget,<cmes>,<cerror>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
**************************************************************************
/*
 GETInvisible met message en error optie
*/
#xcommand @ <row>,<col> GETI <var> LENGTH <nlen> [PICTURE <pic>] ;
 [VALID <valid>] [WHEN <when>] [MESSAGE <cmes>] ;
 [ERROR <cerror>] [SHOWKAR <cshowkar>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|oget|getinvisible(oget,<cmes>,<cerror>, ;
   <cshowkar>,<nlen>)} ;
 ; atail(getlist):colorspec := right(token(colorgeto(),",",1),1) + "/" + ;
  right(token(colorgeto(),",",1),1)+","+right(token(colorgeto(),",",2),1)+ ;
  "/" + right(token(colorgeto(),",",2),1) ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
/*************************************************************************/
#xcommand @ <row>, <col> GET <var> LIST <drops> [VALID <valid>] ;
 [WHEN <when>] => ;
 setpos(<row>,<col>)  ;
 ; aadd(getlist,listgetnew({|x|if(x==NIL,<var>,<var>:= x)} ;
  ,<(var)>,<drops>)) ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]

#xcommand @ <nTop>, <nLeft>, <nBottom>, <nRight> GET <var>     ;
 LIST <drops> [VALID <valid>] [WHEN <when>]  =>       ;
 setpos(<nTop>, <nLeft>)    ;
 ; aadd(getlist,listgetnew({|x|if(x==NIL, <var>, <var> := x) },   ;
  <(var)>, <drops>, <nBottom>, <nRight>)) ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]
/************************************************************************/
/*
 a combo box
*/
#xcommand @ <row>, <col> GET <var> COMBO <drops> [VALID <valid>]   ;
 [WHEN <when>] => ;
 SetPos(<row>, <col>)    ;
 ; aadd(getlist,combogetnew({|x| if(x == NIL, <var>, <var> := x) },  ;
  <(var)>, <drops>)) ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]
/************************************************************************/
/*
 Definition of GET TIMEOUT command.
*/
#xcommand @ <row>, <col> GET <var>                                      ;
                        [<clauses,...>]                                 ;
                        TIMEOUT <n> ACTION <b>                        ;
                        [<moreClauses,...>]                             ;
      => @ <row>, <col> GET <var>                                       ;
                        [<clauses>]                                     ;
                        SEND reader:={|oget|timedreader(oget,<n>,<{b}>)} ;
                        [<moreClauses>]
/************************************************************************/
/*
  @ GET During command.
*/
#xcommand @ <row>, <col> GET <var>                                  ;
                        [<clauses,...>]                             ;
                        DURING <b> EVERY <n>                        ;
                        [<moreClauses,...>]                         ;
    => @ <row>, <col> GET <var>                                     ;
                      [<clauses>]                                   ;
                      SEND reader := {|oGet|getduring(oGet, <{b}>, <n>) } ;
                      [<moreClauses>]
/*************************************************************************/
/*
 Definition of GET PASSWORD command.
*/
#xcommand @ <row>, <col> GET <var>                               ;
                        [<clauses,...>]                          ;
                        PASSWORD                                 ;
                        [<moreClauses,...>]                      ;
      => @ <row>, <col> GET <var>                                ;
                        [<clauses>]                              ;
                        SEND reader := {|oGet|getpassword(oGet) }  ;
                        [<moreClauses>]
/************************************************************************/
/*
  Header file for push button gets.
  Simply evaluate <b> when user presses Enter on this get. <b> may
  return .T. to leave the read, or .F. to remain in the read.
*/
#xcommand @ <row>, <col> GET <var> PUSH <b> [VALID <valid>]  ;
 [WHEN <when>] => ;
 SetPos(<row>, <col>) ;
 ; aadd(getlist,pushgetnew({|x| iif(x == NIL, <var>, <var> := x) },  ;
  <(var)>, <b>)) ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]
/**************************************************************************/
/*
 Definition of translates for simulated Check box class.
*/
#xcommand @ <row>, <col> GET <var> CHKBOX <cStr>   ;
 [VALID <valid>] [WHEN <when>] => ;
 SetPos(<row>, <col>)              ;
 ; aadd(getlist,checkgetnew({|x| iif(x == NIL, <var>, <var> := x) }, ;
  <(var)>, <cStr>)) ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ]
**************************************************************************
/*
 defining @ GET ... MEMO command
*/
#xcommand @ <row>, <col> GET <var> MEMO AT <t>, <l>, <b>, <r> ;
 FILE <cFile> [VALID <valid>] [WHEN <when>]  =>  ;
 SetPos( <row>, <col> )   ;
 ; Aadd(GetList,MemoGetNew(,{|x|if(x==NIL,"Memo",<var>:=x)}, ;
  <(var)>, <{valid}>, <{when}>,{<t>, <l>, <b>, <r>}, <cFile> ))  ;
 ; atail(getlist):colorspec := colorgeto() ;
 ; Atail(GetList):display()

#xcommand @ <row>, <col> GET <var> MEMO AT <t>, <l>, <b>, <r> ;
 [VALID <valid>] [WHEN <when>]  => ;
 SetPos( <row>, <col> )  ;
 ; Aadd(GetList,MemoGetNew(<var>,{|x|if(x==NIL,"Memo",<var>:=x)}, ;
  <(var)>, <{valid}>, <{when}>,{<t>, <l>, <b>, <r>} ))      ;
 ; atail(getlist):colorspec := colorgeto() ;
 ; atail(GetList):display()
**************************************************************************
#xcommand @ <row>,<col> GET <var> PICKLIST <drops> DOUBLE ;
 [COLOR <color>] [POSITION <top>,<left>] [TRANSLATE <ntrans>] ;
 [WHEN <when>] ;
 => setpos(<row>,<col>)    ;
 ; aadd(GetList,PickGetNew({|x|if(x==NIL,<var>,<var>:=x)}, ;
  <(var)>,<drops>,2,<color>,<top>,<left>,<ntrans>,<{when}>)) ;
 ; atail(getlist):colorspec := colorgeto()

#xcommand @ <row>,<col> GET <var> PICKLIST <drops> ;
 [COLOR <color>] [POSITION <top>,<left>] [TRANSLATE <ntrans>] ;
 [WHEN <when>] ;
 => setpos(<row>,<col>)    ;
 ; aadd(GetList,PickGetNew({|x|if(x==NIL,<var>,<var>:=x)}, ;
  <(var)>,<drops>,1,<color>,<top>,<left>,<ntrans>,<{when}>)) ;
 ; atail(getlist):colorspec := colorgeto()
**************************************************************************
#xcommand @ <row>,<col> GETD <var> DROP <droplist> [PICTURE <pic>] ;
 [VALID <valid>] [WHEN <when>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,drop_get({|x|if(x==NIL,<var>,<var>:=x)},<"var">,<droplist>)) ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):colorspec := colorgeto() ;
 ; atail(getlist):display()
***************************************************************************
#xcommand @ <row>, <col> GET <var> RADIOS <radios,...> [BUTTON <csign>] => ;
 setpos(<row>,<col>) ;
 ; radio_get({|x|if(x==NIL,<var>,<var>:=x)},<(var)>,<radios>,getlist, ;
  <csign>) ;
 ; draw_radio(getlist,atail(getlist))
**************************************************************************
#xcommand @ <row>,<col> GET <var> SMART <cfield> [ALIAS <alias>] ;
 [ORDER <norder>] [PICTURE <pic>] [VALID <valid>] [WHEN <when>] ;
 [SEND <msg>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,_GET_(<var>,<(var)>,<pic>,<{valid}>,<{when}>) ;
 ; atail(getlist):reader := {|get|smartreader(get)} ;
 ; atail(getlist):cargo := {<cfield>,<alias>,<norder>} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):<msg>] ;
 ; atail(getlist):display()
***************************************************************************
#xcommand @ <row>,<col> GET <var> CYCLE [LIST <clist_>] [PICTURE <pic>] ;
 [VALID <valid>] [WHEN <when>] [<showday: SHOWDAY>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|oget|cyclereader(oget,<clist_>,<.showday.>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 [; atail(getlist):picture := <pic> ] ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
**************************************************************************
#xcommand @ <row>,<col> GET <var> FILESELECT <csel_files_> ;
 [VALID <valid>] [WHEN <when>] [<mustexist: MUSTEXIST>] ;
 [<multiple: MULTIPLE>] [MAX <nmax>] [DIRECTORY <cdir>] => ;
 setpos(<row>,<col>) ;
 ; aadd(getlist,getnew()) ;
 ; atail(getlist):name := <"var"> ;
 ; atail(getlist):block := {|xval|if(xval==NIL,<var>,<var>:=xval)} ;
 ; atail(getlist):row := <row> ;
 ; atail(getlist):col := <col> ;
 ; atail(getlist):reader := {|oget|filereader(oget,<.mustexist.>, ;
  <.multiple.>,@<csel_files_>,<nmax>,<cdir>)} ;
 ; atail(getlist):colorspec := colorgeto() ;
 ; atail(getlist):picture := "@!" ;
 [; atail(getlist):preblock := <{when}> ] ;
 [; atail(getlist):postblock := <{valid}> ] ;
 ; atail(getlist):display()
**************************************************************************
/*  $DESCRIPTION$
*     The A_CHOICE() UDC makes using TBACHOICE() a breeze.
*     The myriad of parameters can be written in any order.  Only <nToprow>,
*     <nTopcol>, and <aArrey> are required.  See the example below.
*
*  $EXAMPLES$
*  nOpt := A_CHOICE( 7,9,, ARRAY:t_arrey USERFUNC:{|a,b| UserFunc(a,b,any1)};
*          BOXTYPE:B_SINGLE  BOXTITLE:title  SHADOW:"R" TAGCHAR:chr(17);
*          REST_SCREEN:.F. AUTOEXEC:.F. MES_COLOR:MSG_COLOR ELEVBAR:"" ;
*          NOSELCOLOR:"bg/n")
*
*  Check only the RETURNed element:
*  IF Was_Tagged(chr(17),t_arrey,nOpt); MoreProcessing(); END
*
*  Check entire 't_arrey':
*  Aeval( t_arrey,{|e,n| IF( Was_Tagged(chr(17),t_arrey,n ), ;
*                            MoreProcessing(t_arrey),NIL ) } )
*/
#xtrans A_CHOICE(                                                    ;
        <t>,<l>,[<b>],[<r>]                                          ;
        ARRAY:<arr>                                                  ;
        [USERFUNC:<func>]                                            ;
        [BOXTYPE:<bx>]                                               ;
        [BOXCOLOR:<bxc>]                                             ;
        [BOXTITLE:<bxt>]                                             ;
        [TITLEPOS:<bxp>]                                             ;
        [USELCOLOR:<uselc>]                                          ;
        [TITLECOLOR:<ttlc>]                                          ;
        [BAR_COLOR:<barc>]                                           ;
        [HOTKEYCOLOR:<hkcolor>]                                      ;
        [SHADOW:<sh>]                                                ;
        [AUTOEXEC:<aex>]                                             ;
        [MES_ROW:<mrow>]                                             ;
        [MES_COL:<mcol>]                                             ;
        [MES_COLOR:<mcolor>]                                         ;
        [ELEVBAR:<ebar>]                                             ;
        [ELEVBAR_COLOR:<ebarc>]                                      ;
        [ELEVBAR_SIDE:<ebars>]                                       ;
        [NOSELCOLOR:<nscolor>]                                       ;
        [TAGCHAR:<tagch>]                                            ;
        [START_ELEM:<start>]                                         ;
        [REST_SCREEN:<rscrn>]                                        ;
        [TIME_OUT:<timeout>]                                         ;
        [TIME_OUT VALUE:<toval>]                                     ;
        [SAVE_TAGS:<st>]  )                                          ;
        =>                                                           ;
        TBACHOICE(                                                   ;
                   <t>,<l>,[<b>],[<r>],<arr>, [<bx>],                ;
                   [<bxc>], [<bxt>], [<bxp>], [<uselc>], [<ttlc>],   ;
                   [<barc>], [<hkcolor>], [<sh>], [<aex>], [<mrow>], ;
                   [<mcol>], [<mcolor>], [<ebar>], [<ebarc>],        ;
                   [<ebars>], [<nscolor>], [<tagch>], [<start>],     ;
                   [<rscrn>],[<timeout>],[<toval>],[<st>],[<func>]   ;
                 )

#translate WAS_TAGGED(<tchar>,<arr>,<val>)   =>                         ;
           ( <tchar> $ <arr>\[<val>]\[1] )

#translate ONE_TAGGED(<tchar>,<arr>)         =>                         ;
           (Ascan(<arr>,{|e| <tchar> $ e\[1]})) > 0

#translate ALL_TAGGED(<tchar>,<arr>)         =>                         ;
           (Ascan(<arr>,{|e| !(<tchar> $ e\[1]})) ) == 0
**************************************************************************
* end noot.ch
**************************************************************************
